/***********************************************************************/
/*                                                                     */
/*  FILE        :ir_remocon_car_01_rmtv410b.c                          */
/*  DATE        :Wed, Sep 09, 2009                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	vO̓e
************************************************************************/
/*
2009-08-26 : vOJn
2009-09-09 : "ir_remocon_car_01"RMT-V410B(SONY)̃RR[hǉB
*/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		//H8L̖߂g
#include	"iodefine.h"	//I/Õx`
#include	"binary.h"		//C2ig߂̒`

/************************************************************************
	萔̒`iڎwj
************************************************************************/
#define		OK			0		//߂l
#define		NG			-1		//߂l

//Rp,PWM̃p[Zg --------------------------------------------
//@[^ɓd͂鎞ԗŎw
#define		TL3LR		20		//,},[^,%
#define		TL3RR		50		//,},E[^,%
#define		TL2LR		30		//,,[^,%
#define		TL2RR		50		//,,E[^,%
#define		TL1LR		40		//,,[^,%
#define		TL1RR		50		//,,E[^,%

#define		CW4LR		50		//i,4,[^,%
#define		CW4RR		50		//i,4,E[^,%
#define		CW3LR		40		//i,3,[^,%
#define		CW3RR		40		//i,3,E[^,%
#define		CW2LR		30		//i,2,[^,%
#define		CW2RR		30		//i,2,E[^,%
#define		CW1LR		20		//i,1,[^,%
#define		CW1RR		20		//i,1,E[^,%

#define		TR1LR		50		//E,,[^,%
#define		TR1RR		40		//E,,E[^,%
#define		TR2LR		50		//E,,[^,%
#define		TR2RR		30		//E,,E[^,%
#define		TR3LR		50		//E,},[^,%
#define		TR3RR		20		//E,},E[^,%

//\tgEFA^C} ----------------------------------------------------
#define		T0Const		300		//T0(300ms)		ʐMr₦Ă~܂ł̎ԁiR[hj
#define		T1Const		0		//T1(ms)
#define		T2Const		0		//T2(ms)
#define		T3Const		0		//T3(ms)
#define		T4Const		0		//T4(ms)
#define		T5Const		0		//T5(ms)
#define		T6Const		0		//T6(ms)
#define		T7Const		0		//T7(ms)

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// sɊ֌Wϐ ---------------------------------------------------
//,},[^
unsigned int	TurnLeft3L	=	0xffff - ((unsigned long)0xffff * TL3LR / 100);
//,},E[^
unsigned int	TurnLeft3R	=	0xffff - ((unsigned long)0xffff * TL3RR / 100);
//,,[^
unsigned int	TurnLeft2L	=	0xffff - ((unsigned long)0xffff * TL2LR / 100);
//,,E[^
unsigned int	TurnLeft2R	=	0xffff - ((unsigned long)0xffff * TL2RR/ 100);
//,,[^
unsigned int	TurnLeft1L	=	0xffff - ((unsigned long)0xffff * TL1LR/ 100);
//,,E[^
unsigned int	TurnLeft1R	=	0xffff - ((unsigned long)0xffff * TL1RR/ 100);

//i,4,[^
unsigned int	Cw4L		=	0xffff - ((unsigned long)0xffff * CW4LR/ 100);
//i,4,E[^
unsigned int	Cw4R		=	0xffff - ((unsigned long)0xffff * CW4RR/ 100);
//i,3,[^
unsigned int	Cw3L		=	0xffff - ((unsigned long)0xffff * CW3LR/ 100);
//i,3,E[^
unsigned int	Cw3R		=	0xffff - ((unsigned long)0xffff * CW3RR/ 100);
//i,2,[^
unsigned int	Cw2L		=	0xffff - ((unsigned long)0xffff * CW2LR/ 100);
//i,2,E[^
unsigned int	Cw2R		=	0xffff - ((unsigned long)0xffff * CW2RR/ 100);
//i,1,[^
unsigned int	Cw1L		=	0xffff - ((unsigned long)0xffff * CW1LR/ 100);
//i,1,E[^
unsigned int	Cw1R		=	0xffff - ((unsigned long)0xffff * CW1RR/ 100);

//E,,[^
unsigned int	TurnRight1L	=	0xffff - ((unsigned long)0xffff * TR1LR/ 100);
//E,,E[^
unsigned int	TurnRight1R	=	0xffff - ((unsigned long)0xffff * TR1RR/ 100);
//E,,[^
unsigned int	TurnRight2L	=	0xffff - ((unsigned long)0xffff * TR2LR/ 100);
//E,,E[^
unsigned int	TurnRight2R	=	0xffff - ((unsigned long)0xffff * TR2RR/ 100);
//E,},[^
unsigned int	TurnRight3L	=	0xffff - ((unsigned long)0xffff * TR3LR/ 100);
//E,},E[^
unsigned int	TurnRight3R	=	0xffff - ((unsigned long)0xffff * TR3RR/ 100);

// \tgEFA^C}Ɋ֌Wϐ -------------------------------------
struct SoftTimer{					//\tgEFA^C}̍\̃^O
	unsigned char	Status;			//^C}Xe[^X
									// 0:~(^C}gp)
									// 1:X^[gw
									// 2:JEg
									// 3:JEgI
	unsigned long	Count;			//^C}JE^
};
struct SoftTimer TimT0;				//T0^C}
struct SoftTimer TimT1;				//T1^C}
struct SoftTimer TimT2;				//T2^C}
struct SoftTimer TimT3;				//T3^C}
struct SoftTimer TimT4;				//T4^C}
struct SoftTimer TimT5;				//T5^C}
struct SoftTimer TimT6;				//T6^C}
struct SoftTimer TimT7;				//T7^C}

unsigned long	T0 = T0Const;		//T0^C}JE^l
unsigned long	T1 = T1Const;		//T1^C}JE^l
unsigned long	T2 = T2Const;		//T2^C}JE^l
unsigned long	T3 = T3Const;		//T3^C}JE^l
unsigned long	T4 = T4Const;		//T4^C}JE^l
unsigned long	T5 = T5Const;		//T5^C}JE^l
unsigned long	T6 = T6Const;		//T6^C}JE^l
unsigned long	T7 = T7Const;		//T7^C}JE^l

/************************************************************************
	֐̒`
************************************************************************/
void			ccw1(void);				//,1
void			ccw2(void);				//,2
void			ccw3(void);				//,3
void			ccw4(void);				//,4
void			cw1(void);				//Oi,1
void			cw2(void);				//Oi,2
void			cw3(void);				//Oi,3
void			cw4(void);				//Oi,4
void			init_io(void);			//IO|[gCjVCY
void			init_tmb1(void);		//^C}B1CjVCY
void			init_tmz(void);			//^C}ZCjVCY
void			intprog_tmb1(void);		//^C}B1
void			main(void);				//CvO
void			stop(void);				//~
void			turn_left_1(void);		//ij
void			turn_left_2(void);		//ij
void			turn_left_3(void);		//ij
void			turn_right_1(void);		//Eij
void			turn_right_2(void);		//Eij
void			turn_right_3(void);		//Eij

void			run(void);				//s

void			rev_turn_left_1(void);	//ލij
void			rev_turn_left_2(void);	//ލij
void			rev_turn_left_3(void);	//ލij
void			rev_turn_right_1(void);	//މEij
void			rev_turn_right_2(void);	//މEij
void			rev_turn_right_3(void);	//މEij

void			spin_right_1(void);		//E]-1
void			spin_right_2(void);		//E]-2
void			spin_right_3(void);		//E]-3
void			spin_right_4(void);		//E]-4
void			spin_left_1(void);		//]-1
void			spin_left_2(void);		//]-2
void			spin_left_3(void);		//]-3
void			spin_left_4(void);		//]-4

void			init_soft_timer(void);
void			dec_soft_timer(struct SoftTimer *,unsigned long);

unsigned int	IR_rcv(void);			//ԊOM

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	// CjVCY ----------------------------------------------------
	init_io();
	init_soft_timer();
	init_tmb1();
	init_tmz();

	// C[v ------------------------------------------------------
	while(1){
		run();
	}
}

/************************************************************************
	s
************************************************************************/
void run(void)
{
	unsigned int ans;	//ԊOM[`̖߂l

	ans = IR_rcv();
	
	if (ans!=0xffff){
		TimT0.Status = 0;	//^C}Xgbv
		switch(ans){
			case 0x1d0e:	//Oi
				cw4();
				break;
			case 0x1d11:	//Oi&E
				turn_right_3();
				break;
			case 0x1d10:	//Oi&
				turn_left_3();
				break;
			case 0x1d0f:	//
				ccw4();
				break;
			case 0x1d18:	//E]
				spin_right_3();
				break;
		}
		TimT0.Status = 1;	//^C}X^[g
	}

	if (TimT0.Status==3){	//ʐMr₦
		TimT0.Status = 0;	//^C}Xgbv
		stop();	//~
	}
}

/************************************************************************
	[^Xs[hZbg
************************************************************************/
// Oi,1 -------------------------------------------------------------
void cw1(void)
{
	TZ0.GRC = Cw1L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = Cw1R;
	TZ1.GRD = 0xffff;
}

// Oi,2 -------------------------------------------------------------
void cw2(void)
{
	TZ0.GRC = Cw2L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = Cw2R;
	TZ1.GRD = 0xffff;
}

// Oi,3 -------------------------------------------------------------
void cw3(void)
{
	TZ0.GRC = Cw3L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = Cw3R;
	TZ1.GRD = 0xffff;
}

// Oi,4 -------------------------------------------------------------
void cw4(void)
{
	TZ0.GRC = Cw4L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = Cw4R;
	TZ1.GRD = 0xffff;
}

// ,1 -------------------------------------------------------------
void ccw1(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw1L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw1R;
}

// ,2 -------------------------------------------------------------
void ccw2(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw2L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw2R;
}

// ,3 -------------------------------------------------------------
void ccw3(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw3L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw3R;
}

// ,4 -------------------------------------------------------------
void ccw4(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw4L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw4R;
}

// Eij ---------------------------------------------------------
void turn_right_1(void)
{
	TZ0.GRC = TurnRight1L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnRight1R;
	TZ1.GRD = 0xffff;
}

// Eij ---------------------------------------------------------
void turn_right_2(void)
{
	TZ0.GRC = TurnRight2L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnRight2R;
	TZ1.GRD = 0xffff;
}

// Eij ---------------------------------------------------------
void turn_right_3(void)
{
	TZ0.GRC = TurnRight3L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnRight3R;
	TZ1.GRD = 0xffff;
}

// ij ---------------------------------------------------------
void turn_left_1(void)
{
	TZ0.GRC = TurnLeft1L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnLeft1R;
	TZ1.GRD = 0xffff;
}

// ij ---------------------------------------------------------
void turn_left_2(void)
{
	TZ0.GRC = TurnLeft2L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnLeft2R;
	TZ1.GRD = 0xffff;
}

// ij ---------------------------------------------------------
void turn_left_3(void)
{
	TZ0.GRC = TurnLeft3L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnLeft3R;
	TZ1.GRD = 0xffff;
}

// މEij -----------------------------------------------------
void rev_turn_right_1(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = TurnRight1L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = TurnRight1R;
}

// މEij -----------------------------------------------------
void rev_turn_right_2(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = TurnRight2L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = TurnRight2R;
}

// މEij -----------------------------------------------------
void rev_turn_right_3(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = TurnRight3L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = TurnRight3R;
}

// ލij -----------------------------------------------------
void rev_turn_left_1(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = TurnLeft1L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = TurnLeft1R;
}

// ލij -----------------------------------------------------
void rev_turn_left_2(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = TurnLeft2L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = TurnLeft2R;
}

// ލij -----------------------------------------------------
void rev_turn_left_3(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = TurnLeft3L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = TurnLeft3R;
}

// ~ -----------------------------------------------------------------
void stop()
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = 0xffff;
	TZ1.GRC = 0xffff;
	TZ1.GRD = 0xffff;
}

// E]-1 -------------------------------------------------------------
void spin_right_1(void)
{
	TZ0.GRC = Cw1L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw1R;
}

// E]-2 -------------------------------------------------------------
void spin_right_2(void)
{
	TZ0.GRC = Cw2L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw2R;
}

// E]-3 -------------------------------------------------------------
void spin_right_3(void)
{
	TZ0.GRC = Cw3L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw3R;
}

// E]-4 -------------------------------------------------------------
void spin_right_4(void)
{
	TZ0.GRC = Cw4L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw4R;
}

// ]-1 -------------------------------------------------------------
void spin_left_1(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw1L;
	TZ1.GRC = Cw1R;
	TZ1.GRD = 0xffff;
}

// ]-2 -------------------------------------------------------------
void spin_left_2(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw2L;
	TZ1.GRC = Cw2R;
	TZ1.GRD = 0xffff;
}

// ]-3 -------------------------------------------------------------
void spin_left_3(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw3L;
	TZ1.GRC = Cw3R;
	TZ1.GRD = 0xffff;
}

// ]-4 -------------------------------------------------------------
void spin_left_4(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw4L;
	TZ1.GRC = Cw4R;
	TZ1.GRD = 0xffff;
}

/************************************************************************
	I/O|[g CjVCY
************************************************************************/
void init_io(void)
{
	IO.PCR6			=	_00000000B;	//|[g6,P60-67

	IO.PCR7			=	_00000000B;	//|[g7,P77-70
}

/************************************************************************
	^C}Z CjVCY
************************************************************************/
void init_tmz(void)
{
	TZ.TSTR.BYTE	=	0x00;	//TCNT0,1 ~

	TZ0.TCR.BYTE	=	0x20;	//GRÃRyA}b`TCNT=0,/1
	TZ1.TCR.BYTE	=	0x20;	//GRÃRyA}b`TCNT=0,/1

	TZ.TPMR.BYTE	=	0x66;	//FTIOC0,FTIOD0,FTIOC1,FTIOD1 PWM[h
	TZ.TOCR.BYTE	=	0x00;	//o,All Low

	TZ0.POCR.BYTE	=	0x06;	//FTIOC0,FTIOD0 o̓nCANeBu
	TZ1.POCR.BYTE	=	0x06;	//FTIOC1,FTIOD1 o̓nCANeBu

	TZ0.GRA			=	0xfffe;	//PWM (65534*(1/20MHz)=3.2767ms)
	TZ1.GRA			=	0xfffe;	//PWM (65534*(1/20MHz)=3.2767ms)
	TZ0.GRC			=	0xffff;	//FTIOC0=Low
	TZ1.GRC			=	0xffff;	//FTIOC1=Low
	TZ0.GRD			=	0xffff;	//FTIOD0=Low
	TZ1.GRD			=	0xffff;	//FTIOD1=Low

	TZ.TOER.BYTE	=	0x33;	//FTIOC0,DTIOD0.FTIOC1,FTIOD1 o͋

	TZ0.TCNT		=	0x0000;	//TCNT0=0
	TZ1.TCNT		=	0x0000;	//TCNT1=0
	TZ.TSTR.BYTE	=	0x03;	//TCNT0 JEgX^[g
}

/************************************************************************
	^C}B1 CjVCY
************************************************************************/
void init_tmb1(void)
{
	TB1.TMB1.BYTE		=	0xf9;	//I[g[hCNbN/2048
	TB1.TLB1			=	0-97;	//=10ms(100Hz)
	IRR2.BIT.IRRTB1		=	0;		//^C}B1ݗvtO NA
	IENR2.BIT.IENTB1	=	1;		//^C}B1ݗvCl[u
}

/************************************************************************
	^C}B1 (10ms)
************************************************************************/
#pragma regsave (intprog_tmb1)
void intprog_tmb1(void)
{
	//^C}B1ݗvtO NA
	IRR2.BIT.IRRTB1 = 0;


	//\tgEFA^C} T0
	if (TimT0.Status==1 || TimT0.Status==2){
		dec_soft_timer(&TimT0,T0/10);
	}
	//\tgEFA^C} T1
	if (TimT1.Status==1 || TimT1.Status==2){
		dec_soft_timer(&TimT1,T1/10);
	}
	//\tgEFA^C} T2
	if (TimT2.Status==1 || TimT2.Status==2){
		dec_soft_timer(&TimT2,T2/10);
	}
	//\tgEFA^C} T3
	if (TimT3.Status==1 || TimT3.Status==2){
		dec_soft_timer(&TimT3,T3/10);
	}
	//\tgEFA^C} T4
	if (TimT4.Status==1 || TimT4.Status==2){
		dec_soft_timer(&TimT4,T4/10);
	}
	//\tgEFA^C} T5
	if (TimT5.Status==1 || TimT5.Status==2){
		dec_soft_timer(&TimT5,T5/10);
	}
	//\tgEFA^C} T6
	if (TimT6.Status==1 || TimT6.Status==2){
		dec_soft_timer(&TimT6,T6/10);
	}
	//\tgEFA^C} T7
	if (TimT7.Status==1 || TimT7.Status==2){
		dec_soft_timer(&TimT7,T7/10);
	}
}

/************************************************************************
	\tgEFA^C}̃fNg
-------------------------------------------------------------------------
			*pst		\tgEFA^C}\̂̃|C^
			initial		^C}JE^̏l
************************************************************************/
void dec_soft_timer(struct SoftTimer *pst,unsigned long initial)
{
	if (pst->Status==1){			//^C}X^[gw
		pst->Status	=	2;			//JEgZbg
		pst->Count	=	initial;	//^C}JE^
	}
	pst->Count--;	//JE^-1
	if (pst->Count==0)				//JE^0ɂȂ
		pst->Status	=	3;			//JEgIZbg
}

/************************************************************************
	\tgEFA^C}̃CjVCY
************************************************************************/
void init_soft_timer(void)
{
	TimT0.Status = 0; TimT1.Status = 0; TimT2.Status = 0; TimT3.Status = 0;
	TimT4.Status = 0; TimT5.Status = 0; TimT6.Status = 0; TimT7.Status = 0;
}
